<?php

/**
 * Default views include file for the status_router module
 *
 * @file: status_router.views.inc
 * @author: Elliott Foster
 * @copyright: NewMBC 2009
 */

/**
 * Implementation of hook_views_data()
 */
function status_router_views_data() {
  $data = array();

  $data['status_router_statuses'] = array(
    'table' => array(
      'group' => t('Status Router Statuses'),
      'join' => array(
        'node' => array(
          'left_field' => 'nid',
          'field' => 'nid',
        ),
        'user' => array(
          'left_field' => 'uid',
          'field' => 'aid',
        ),
      ),
    ),
    'nid' => array(
      'title' => t('Node ID'),
      'help' => t('The status node ID'),
    ),
    'uid' => array(
      'title' => t('Author'),
      'help' => t('The user that posted the status'),
      'filter' => array(
        'handler' => 'views_handler_filter_user_current',
      ),
    ),
    'aid' => array(
      'title' => t('Account'),
      'help' => t('The user the status was posted to to'),
      'filter' => array(
        'handler' => 'views_handler_filter_user_current',
      ),
    ),
  );

  return $data;
}

